<?php

//define('OI_BACKEND_URL', 'http://dims-api.netnode.lo:100');
define('OI_BACKEND_URL', 'http://dims-api.netnode.ch');

class OI {

    var $api_key = '';
    var $tracking_id = '';

    public final function __construct($tracking_id, $api_key)
    {
        $this->tracking_id = $tracking_id;
        $this->api_key = $api_key;
    }

    public function queryContacts($params) {
        $array = json_decode(file_get_contents(OI_BACKEND_URL.'/api/v1/contact?tracking_id='.$this->tracking_id.'&limit=100'));
        return $array;
    }

    public function queryEvents($params) {
        $get_params = '';
        foreach ($params as $key=>$value) {
            $get_params .= '&'.$key.'='.$value;
        }
        $url = OI_BACKEND_URL.'/api/v1/event?tracking_id='.$this->tracking_id.'&limit=100&'.$get_params;
        //debug_raw($url);
        $array = json_decode(file_get_contents($url));
        return $array;
    }

    public function getContact($id) {
        $array = json_decode(file_get_contents(OI_BACKEND_URL.'/api/v1/contact/'.$id.'?tracking_id='.$this->tracking_id.'&limit=10'));
        return $array;
    }

    public function addContact($params) {
        $post_json = json_encode($params);
        $endpoint = OI_BACKEND_URL.'/api/v1/contact?tracking_id='.$this->tracking_id;
        $ch = @curl_init();
        @curl_setopt($ch, CURLOPT_POST, true);
        @curl_setopt($ch, CURLOPT_POSTFIELDS, $post_json);
        @curl_setopt($ch, CURLOPT_URL, $endpoint);
        @curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
        @curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $response = @curl_exec($ch);
        $status_code = @curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $curl_errors = curl_error($ch);
        @curl_close($ch);
        //echo "curl Errors: " . $curl_errors;
        //echo "\nStatus code: " . $status_code;
        //echo "\nResponse: " . $response;
    }

    public function updateContact($id, $properties) {
        $post_json = json_encode($properties);
        $endpoint = OI_BACKEND_URL.'/api/v1/contact/'.$id.'?tracking_id='.$this->tracking_id;
        $ch = @curl_init();
        @curl_setopt($ch, CURLOPT_POST, true);
        @curl_setopt($ch, CURLOPT_POSTFIELDS, $post_json);
        @curl_setopt($ch, CURLOPT_URL, $endpoint);
        @curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
        @curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $response = @curl_exec($ch);
        $status_code = @curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $curl_errors = curl_error($ch);
        @curl_close($ch);
        //echo "curl Errors: " . $curl_errors;
        //echo "\nStatus code: " . $status_code;
        //debug_raw($response);
    }
}